function checkCollision(x1,y1,w1,h1,x2,y2,w2,h2)
	local bbleft1 = x1 - w1
	local bbright1 = x1 + w1
	local bbup1 = y1 - h1
	local bbdown1 = y1 + h1

	local bbleft2 = x2 - w2
	local bbright2 = x2 + w2
	local bbup2 = y2 - h2
	local bbdown2 = y2 + h2



	if (bbright1 > bbleft2 and bbleft1 < bbright2) and (bbup1 < bbdown2 and bbdown1 > bbup2) then

		return true
	else
		return false

	end

end


require "ball"
require "player"
require "opponent"

--LOAD--
function love.load()
	ballLoad()
	playerLoad()
	opponentLoad()
	fieldImg = love.graphics.newImage("images/field.png")
	scorePlayer = 0
	scoreOpponent = 0
	scoreFont = love.graphics.newFont("images/Score Font.TTF", 80);
	gameState = "menu"
	selectP = 0
	gameP = 0
	winner = " "
	sndStart = love.audio.newSource("audio/start.wav","static")
	endScore = 5


end

--UPDATE--
function love.update(dt)
	if (gameState == "menu") then
			scorePlayer = 0
			scoreOpponent = 0
		if (love.keyboard.isDown("down")) then
			selectP = 1
			end
		if (love.keyboard.isDown("up")) then
			selectP = 0
		end

		if (love.keyboard.isDown("return")) then
			love.audio.play(sndStart)
			gameP = selectP
			gameState = "game"
		end
	end

	if (gameState == "game") then
	ballUpdate(dt)
	playerUpdate(dt)
	opponentUpdate(dt)
	if (checkCollision(ball.posX,ball.posY,ball.w,ball.h,player.posX,player.posY,player.w,player.h)) then

		ball.hspeed = math.abs(ball.hspeed) + ball.acc
		ball.vspeed = (ball.posY - player.posY) * 7
		ball.posX = player.posX + player.w + ball.w
		local bounceNumber = math.floor(math.random()*3)
		if (bounceNumber==0) then
		love.audio.play(ball.sndBounce1)
		elseif (bounceNumber==1) then
		love.audio.play(ball.sndBounce2)
		elseif (bounceNumber==2) then
		love.audio.play(ball.sndBounce3)
		end

	end

	if (checkCollision(ball.posX,ball.posY,ball.w,ball.h,opponent.posX,opponent.posY,opponent.w,opponent.h)) then

		ball.hspeed = -ball.hspeed - ball.acc
		ball.vspeed = (ball.posY - opponent.posY) * 7
		ball.posX = opponent.posX - opponent.w - ball.w
		local bounceNumber = math.floor(math.random()*3)
		if (bounceNumber==0) then
		love.audio.play(ball.sndBounce1)
		elseif (bounceNumber==1) then
		love.audio.play(ball.sndBounce2)
		elseif (bounceNumber==2) then
		love.audio.play(ball.sndBounce3)
		end

	end

	if (scorePlayer>=endScore) then
		winner = "Player 1 won!"
		gameState = "menu"
	elseif (scoreOpponent>=endScore) then
		if (selectP == 0) then
			winner = "CPU won!"
			gameState = "menu"
		elseif (selectP == 1) then
			winner = "Player 2 won!"
			gameState = "menu"
		end
	end

end
end



--DRAW--
function love.draw()
	if (gameState == "game") then

	love.graphics.setColor(255,255,255)
	love.graphics.draw(fieldImg,0,0)
	playerDraw()
	opponentDraw()
	ballDraw()
	love.graphics.setFont(scoreFont)
	love.graphics.print(scorePlayer,200,10)
	love.graphics.print(scoreOpponent,600,10)

end

	if (gameState == "menu") then
		love.graphics.setColor(255,255,255)
		love.graphics.setFont(scoreFont)
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",0,0,800,500)
		love.graphics.setColor(255,255,255)
		love.graphics.printf("PONG",0,20,800,"center")
		love.graphics.printf(winner,0,100,800,"center")
		if (selectP == 0) then
		love.graphics.printf("> Player vs CPU",-300,200,800,"right")
		love.graphics.printf("  Player vs Player",-200,300,800,"right")
		elseif (selectP == 1) then
		love.graphics.printf(" Player vs CPU",-300,200,800,"right")
		love.graphics.printf(">  Player vs Player",-200,300,800,"right")

		end

	end

end